﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Based on sorting code from Reginal Venaglia
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SortCategoryEntries()
  
  ;------------------------------------------------------------------------------------------------
  ; Get number items in ListIcon
  ;------------------------------------------------------------------------------------------------
  
  NumberOfItems.i = CountGadgetItems(#Gadget_Keeper_Category)
  
  ;------------------------------------------------------------------------------------------------
  ; Get number items in ListIcon
  ;------------------------------------------------------------------------------------------------
  
  If NumberOfItems.i > 9
    
    ;----------------------------------------------------------------------------------------------
    ; Get number items in ListIcon
    ;----------------------------------------------------------------------------------------------
    
    NewList Categories.CategoryData()
    
    ;----------------------------------------------------------------------------------------------
    ; Place each item text into the list. Must start at Zero
    ;----------------------------------------------------------------------------------------------
    
    For LoopCounter.i = 0 To NumberOfItems.i - 1
      
      AddElement(Categories())
      
      Categories()\Category     = GetGadgetItemText(#Gadget_Keeper_Category, LoopCounter.i, #CategoryTitleColumn)
      
      Categories()\ItemCount    = GetGadgetItemText(#Gadget_Keeper_Category, LoopCounter.i, #CategoryItemsColumn)
      
      Categories()\Iconname     = GetGadgetItemText(#Gadget_Keeper_Category, LoopCounter.i, #CategoryIconColumn)
      
      Categories()\Categoryid   = GetGadgetItemText(#Gadget_Keeper_Category, LoopCounter.i, #CategoryRecordColumn)
      
    Next LoopCounter 
    
    ;----------------------------------------------------------------------------------------------
    ; Sort the Array in ascending order
    ;----------------------------------------------------------------------------------------------
    
    SortStructuredList(Categories(), #PB_Sort_Ascending, OffsetOf(CategoryData\Category), #PB_String, 9, ListIndex(Categories()))
    
    ;----------------------------------------------------------------------------------------------
    ; Now replace ListIcon Items from the sorted Array
    ;----------------------------------------------------------------------------------------------
    
    ForEach Categories()
      
      SetGadgetItemText(#Gadget_Keeper_Category, ListIndex(Categories()), Categories()\Category,    #CategoryTitleColumn)
      
      SetGadgetItemText(#Gadget_Keeper_Category, ListIndex(Categories()), Categories()\Itemcount,   #CategoryItemsColumn)
      
      SetGadgetItemText(#Gadget_Keeper_Category, ListIndex(Categories()), Categories()\Iconname,    #CategoryIconColumn)
      
      SetGadgetItemText(#Gadget_Keeper_Category, ListIndex(Categories()), Categories()\Categoryid,  #CategoryRecordColumn)
      
      If HighlightString.s = Categories()\Category
        
        LineToHighLight.i  = ListIndex(Categories())
        
      EndIf
      
    Next Categories()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClearList(Categories())
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetState(#Gadget_Keeper_Category, LineToHighLight.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 95
; FirstLine = 50
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0