﻿;================================================================================================================================================================================
; Rebuild the image list as it gets trashed by the clear command
;================================================================================================================================================================================

Procedure BuildImageList(Gadget.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Create a new image list for the ListIconGadget if it doesn't exist or has been destroyed
  ;------------------------------------------------------------------------------------------------
  
  If Icon\HeaderListIcon = 0
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Icon\HeaderListIcon       = ImageList_Create_(16, 16, #ILC_MASK | #ILC_COLOR32, 0, 4)
    
    ;----------------------------------------------------------------------------------------------
    ; Add the deleted icon to the new imagelist
    ;----------------------------------------------------------------------------------------------
    
    Icon\ListNormal           = ImageList_ReplaceIcon_(Icon\HeaderListIcon, #AtTheEndOfTheList, ImageID(#Image_ListNormal))
    
    Icon\ListLocked           = ImageList_ReplaceIcon_(Icon\HeaderListIcon, #AtTheEndOfTheList, ImageID(#Image_ListLocked))
    
    Icon\ListFavourite        = ImageList_ReplaceIcon_(Icon\HeaderListIcon, #AtTheEndOfTheList, ImageID(#Image_ListFavourite))
    
    Icon\ListDeleted          = ImageList_ReplaceIcon_(Icon\HeaderListIcon, #AtTheEndOfTheList, ImageID(#Image_ListDeleted))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Set the new imagelist to the gadget
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(Gadget.i), #LVM_SETIMAGELIST, #LVSIL_SMALL, Icon\HeaderListIcon)
  
  ImageList_SetBkColor_(Icon\HeaderListIcon, #CLR_NONE)  
  
  SendMessage_(GadgetID(Gadget.i), #LVM_SETEXTENDEDLISTVIEWSTYLE, #LVS_EX_SUBITEMIMAGES, #LVS_EX_SUBITEMIMAGES) 
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 28
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0