﻿;==========================================================================================================================================================
; First letter uppercase in a combo box. srod!.
;==========================================================================================================================================================

Procedure MixedComboCaseEx(Gadget.i)
  
  ;------------------------------------------------------------------------------------------------
  ; NetMaestro
  ;------------------------------------------------------------------------------------------------
  
  CompilerIf Defined(CBEM_GETEDITCONTROL, #PB_Constant) = 0
    
    #CBEM_GETEDITCONTROL = #WM_USER + 7
    
  CompilerEndIf
  
  Protected cn.s, cbParent.i, StringOut.s, StringIn.s, Temporary.s, Position.i, StartSelection.i, EndSelection.i
  
  StringIn.s = GetGadgetText(Gadget.i)
  
  If StringIn.s = ""
    
    ProcedureReturn
    
  EndIf
  
  WordFlag.i = 1
  
  cn.s = Space(255)
  
  GetClassName_(GadgetID(Gadget.i), @cn, 254)
  
  If FindString(LCase(cn), "comboboxex32")
    
    cbParent.i = SendMessage_(GadgetID(Gadget.i), #CBEM_GETEDITCONTROL, 0, 0)
    
  Else
    
    cbParent.i = FindWindowEx_(GadgetID(Gadget.i), #Null, "EDIT", #Null)
    
  EndIf
  
  SendMessage_(cbParent.i, #EM_GETSEL, @StartSelection, @EndSelection)      ; Get the Position of the caret.
  
  SendMessage_(cbParent.i, #EM_SETSEL, -1, EndSelection)
  
  Repeat
    
    Position.i + 1
    
    StringOut.s = Mid(StringIn.s, Position.i, 1)
    
    If WordFlag.i
      
      Temporary.s + UCase(StringOut.s)
      
    Else
      
      Temporary.s + StringOut.s
      
    EndIf
    
    If StringOut.s = " "
      
      WordFlag.i = 1
      
    Else
      
      WordFlag.i = 0
      
    EndIf
    
  Until Position.i = Len(StringIn.s)
  
  SetGadgetText(Gadget.i, Temporary.s)
  
  ; Return the caret to it's original Position
  
  SendMessage_(cbParent.i, #EM_SETSEL, EndSelection.i, EndSelection.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 4
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP