﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Fill a combobox gadget from a linked list, SQLite version
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure FillCombo(Gadget.i, DatabaseQuery.s, ColumnIcon.i = 0)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ClearGadgetItems(Gadget.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
    
    While NextDatabaseRow(Program\DatabaseHandle)
      
      Categoryname.s = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0))
      
      If Categoryname.s <> #Empty$
        
        If ColumnIcon.i <> 0
          
          AddGadgetItem(Gadget.i, #AtTheEndOfTheList, Categoryname.s, ImageID(ColumnIcon.i))
          
        Else
          
          AddGadgetItem(Gadget.i, #AtTheEndOfTheList, Categoryname.s)
          
        EndIf
        
      EndIf
      
    Wend
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 6
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0