﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Print all or selected records
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure PrintThisDatae()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  NumberOfItems.i = CountGadgetItems(#Gadget_Keeper_Titles) - 1
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Program\WindowMutex <> #True
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Window_printe()
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Message.s = "Print all selected keeper items in the list"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetWindowTitle(#Window_printe, Message.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings",  "Info", Message.s, #PB_Compiler_Procedure)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Program\WindowMutex = #True
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If NumberOfItems.i  <> #NoItems
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        PrintFileId.i = CreateFile(#PB_Any, Program\WebPrintFile)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If PrintFileId.i  <> #NoPrintFileHandle
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          For PrintLoop.i = 0 To NumberOfItems.i
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If GetGadgetItemState(#Gadget_Keeper_Titles, PrintLoop.i) & #PB_ListIcon_Selected
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              Record.s = GetGadgetItemText(#Gadget_Keeper_Titles, PrintLoop.i, #RecordColumn)
              
              If DatabaseQuery(Program\DatabaseHandle, "SELECT * FROM Keeper WHERE Record = '" + Record.s + "'")
                
                PseudoCounter + 1
                
                While NextDatabaseRow(Program\DatabaseHandle)
                  
                  Title.s       = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))  : ; Debug Title.s       ; Title
                  
                  Information.s = KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))  : ; Debug Information.s ; Information
                  
                Wend
                
                FinishDatabaseQuery(Program\DatabaseHandle)
              
              Else
                
                SetInfoBarArea("Headings", "Error", "The current SQL query failed to be executed.", #PB_Compiler_Procedure)
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              AddGadgetItem(#Gadget_Printe_Items, #AtTheEndOfTheList, Title.s)
              AddGadgetItem(#Gadget_Printe_Items, #AtTheEndOfTheList, Empty$)
              AddGadgetItem(#Gadget_Printe_Items, #AtTheEndOfTheList, Information.s)
              AddGadgetItem(#Gadget_Printe_Items, #AtTheEndOfTheList, "--------------------------------------------------")
 
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              
            EndIf
            
          Next PrintLoop.i
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          CloseFile(PrintFileId.i)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetText(#Gadget_Printe_Record, Str(PseudoCounter.i))
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetActiveWindow(#Window_printe)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetActiveGadget(#Gadget_Printe_Items)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "Could not create ouput print file", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Info", "No items in the list to process", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", "Cannot open the Keeper print window", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "There is another program window open, cannot open another one", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure



; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 148
; FirstLine = 115
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0