﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Backup the current database to the named day of the week
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure BackupDatabase()
  
  ;------------------------------------------------------------------------------------------------
  ; Get the current named day of the week
  ;------------------------------------------------------------------------------------------------
  
  CurrentDayName.s = NameOfDay(DayOfWeek(Date()))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  BackupDatabaseName.s = Program\BackupDirectory + GetFilePart(Program\DatabaseName) + "." + Left(CurrentDayName, 3)
  
  ;------------------------------------------------------------------------------------------------
  ; Try to create a backup of the database now
  ;------------------------------------------------------------------------------------------------
  
  If CopyFile(Program\DatabaseName, BackupDatabaseName.s) <> #FileNotCopied
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings", "Info", "The database tables have been backed up to: " + BackupDatabaseName.s, #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    MessageRequester("MyStuff backup", "The database has been backed up to: " + #CRLF$ + #CRLF$ + BackupDatabaseName.s, #PB_MessageRequester_Ok | #MB_ICONINFORMATION)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "The database could not be backed up, program or disk error.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure



; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0