﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Create the new owners table on startup and insert them
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure   OneTimeMakeOwners()
  
  DatabaseQuery.s = "SELECT DISTINCT Owner FROM Keeper ORDER BY Owner"
  
  If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
    
    While NextDatabaseRow(Program\DatabaseHandle)  <> #NoItems
      
      OwnerName.s = GetDatabaseString(Program\DatabaseHandle, 0)
      
      OwnerName.s = UCase(Left(OwnerName.s, 1)) + Mid(OwnerName.s, 2, Len(OwnerName.s) - 1)
      
      OwnerName.s = RepQuote(OwnerName.s)
      
      DatabaseUpdate.s  = "INSERT INTO Owners(Owner, Iconname, Itemcount) VALUES('" + OwnerName.s  + "','', '0')"
      
      If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <>  #DatabaseUpdateFail
        
        ; The update worked
        
      Else
        
        Debug DatabaseUpdate.s  + " ::: "  + DatabaseError()  
        
      EndIf
      
    Wend
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
  Else
    
    Debug DatabaseQuery.s  + " ::: "  + DatabaseError()
    
  EndIf
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0