;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Check the unlocking password
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure CheckUnlockPassWord()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  FocusId.i = GetActiveGadget()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select FocusId.i

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
      
    Case  #Gadget_UnlockPassword_UnlockPassWord
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
      QueryString.s = "SELECT MD5FingerPrint FROM Preferences "
      
      QueryString.s + "WHERE Record = '1'"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseQuery(Program\DatabaseHandle, QueryString.s)
        
        While NextDatabaseRow(Program\DatabaseHandle)
          
          StoredPassWord.s = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0))
          
        Wend
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
      EndIf
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      NewPassWord.s    = GetGadgetText(#Gadget_UnlockPassword_UnlockPassWord)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      MessageString.s = "The password field must not be empty."                   + #CRLF$ + #CRLF$
      
      MessageString.s + "You have to type in a password to unlock the program."   + #CRLF$ + #CRLF$
      
      MessageString.s + "Try again."
      
      If NewPassWord.s = #Empty$
        
        MessageRequester("Security Error",  MessageString.s,  #MB_ICONWARNING)
        
        SetGadgetText(#Gadget_UnlockPassword_UnlockPassWord, #Empty$)
        
        SetActiveGadget(#Gadget_UnlockPassword_UnlockPassWord)
        
      ElseIf NewPassWord.s <> #Empty$
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        NewPassWord.s    = Fingerprint(@NewPassWord,  Len(NewPassWord.s), #PB_Cipher_MD5)

        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        MessageString.s = "The passwords do not match." + #CRLF$ + #CRLF$
        
        MessageString.s + "Try again."
        
        If NewPassWord.s <> StoredPassWord.s
          
          MessageRequester("Security Error",  MessageString.s,  #MB_ICONWARNING)
          
          SetGadgetText(#Gadget_UnlockPassword_UnlockPassWord, #Empty$)
          
          SetActiveGadget(#Gadget_UnlockPassword_UnlockPassWord)
          
        ElseIf  NewPassWord.s = StoredPassWord.s
          
          Program\LockState = #False
          
          CloseMyWindow(#Window_UnlockPassword)
          
          ShowProgramWindow()
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
    
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0