;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Open the new password window
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure NewPassWordWindow()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Window_NewPassword()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Global QuitPasswordValue.i = #False
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    StickyWindow(#Window_NewPassword, #True)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\LastWindow = #Program + " new password"
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    AddKeyboardShortcut(#Window_NewPassword, #ShortcutValue_NewPassword_Return, #KeyboardShortcut_NewPassword_Return)
    
    AddKeyboardShortcut(#Window_NewPassword, #ShortcutValue_NewPassword_Escape, #KeyboardShortcut_NewPassword_Escape)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetWindowTitle(#Window_NewPassword, "New password between 7 and 26 characters")
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetActiveGadget(#Gadget_NewPassword_NewPassWord)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    HideWindow(#Window_NewPassword, #False)
    
    ;----------------------------------------------------------------------------------------------
    ; Main event processing area
    ;----------------------------------------------------------------------------------------------
    
    Repeat
      
      EventID  =  WaitWindowEvent()
      MenuID   =  EventMenu()
      GadgetID =  EventGadget()
      WindowID =  EventWindow()
      
      ;------------------------------------------
      ; 
      ;------------------------------------------
      
      Select EventID

        ;----------------------------------------
        ; 
        ;----------------------------------------

        Case #PB_Event_CloseWindow
          Select WindowID
            Case #Window_NewPassword                                          : End
          EndSelect
          
          ;--------------------------------------
          ; 
          ;--------------------------------------
          
        Case #PB_Event_Menu
          
          Select MenuID
              
            Case #KeyboardShortcut_NewPassword_Return                         : CheckNewPassWord()

            Case #KeyboardShortcut_NewPassword_Escape                         : End

          EndSelect
          
          ;--------------------------------------
          ; 
          ;--------------------------------------
          
        Case #PB_Event_Gadget
          
          Select GadgetID
              
            Case #Gadget_NewPassword_NewPassWord
              
              Select EventType()
                  
                Case #PB_EventType_Focus
                  
              EndSelect
              
          EndSelect
          
          ;--------------------------------------
          ; 
          ;--------------------------------------
          
      EndSelect
      
      ;------------------------------------------
      ; 
      ;------------------------------------------
      
    Until QuitPasswordValue.i = #True
    
    ;------------------------------------------
    ; 
    ;------------------------------------------
    
    CloseWindow(#Window_NewPassword)
    
    ;------------------------------------------
    ; 
    ;------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 93
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0