﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Sort ListIconGadget as you need it. Based on Reg Venaglia's routine.
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SortTitleStrings(HighlightString.s)
  
  ;------------------------------------------------------------------------------------------------
  ; Get number items in ListIcon
  ;------------------------------------------------------------------------------------------------
  
  NumberOfItems.i = CountGadgetItems(#Gadget_Keeper_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; Get number items in ListIcon
  ;------------------------------------------------------------------------------------------------
  
  If NumberOfItems.i > 2
    
    ;----------------------------------------------------------------------------------------------
    ; Get number items in ListIcon
    ;----------------------------------------------------------------------------------------------
    
    NewList Keeper.KeeperData()
    
    ;----------------------------------------------------------------------------------------------
    ; Place each item text into the list. Must start at Zero
    ;----------------------------------------------------------------------------------------------
    
    For LoopCounter.i = 0 To NumberOfItems.i - 1
      
      AddElement(Keeper())
      
      Keeper()\Title         = GetGadgetItemText(#Gadget_Keeper_Titles, LoopCounter.i, 0)
      
      Keeper()\Category      = GetGadgetItemText(#Gadget_Keeper_Titles, LoopCounter.i, 1)
      
      Keeper()\Favourite     = GetGadgetItemText(#Gadget_Keeper_Titles, LoopCounter.i, 2)
      
      Keeper()\Locked        = GetGadgetItemText(#Gadget_Keeper_Titles, LoopCounter.i, 3)
      
      Keeper()\Deleted       = GetGadgetItemText(#Gadget_Keeper_Titles, LoopCounter.i, 4)
      
      Keeper()\Owner         = GetGadgetItemText(#Gadget_Keeper_Titles, LoopCounter.i, 5)
      
      Keeper()\Updated       = GetGadgetItemText(#Gadget_Keeper_Titles, LoopCounter.i, 6)
      
      Keeper()\Attachments   = GetGadgetItemText(#Gadget_Keeper_Titles, LoopCounter.i, 7)
      
      Keeper()\Record        = GetGadgetItemText(#Gadget_Keeper_Titles, LoopCounter.i, 8)
      
    Next LoopCounter 
    
    ;----------------------------------------------------------------------------------------------
    ; Sort the Array in ascending order
    ;----------------------------------------------------------------------------------------------
    
    SortStructuredList(Keeper(), #PB_Sort_Ascending, OffsetOf(KeeperData\Title), #PB_String, 0, ListIndex(Keeper()))
    
    ;----------------------------------------------------------------------------------------------
    ; Now replace ListIcon Items from the sorted Array
    ;----------------------------------------------------------------------------------------------
    
    ForEach Keeper()
      
      SetGadgetItemText(#Gadget_Keeper_Titles, ListIndex(Keeper()), Keeper()\Title,       0)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, ListIndex(Keeper()), Keeper()\Category,    1)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, ListIndex(Keeper()), Keeper()\Favourite,   2)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, ListIndex(Keeper()), Keeper()\Locked,      3)

      SetGadgetItemText(#Gadget_Keeper_Titles, ListIndex(Keeper()), Keeper()\Deleted,     4)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, ListIndex(Keeper()), Keeper()\Owner,       5)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, ListIndex(Keeper()), Keeper()\Updated,     6)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, ListIndex(Keeper()), Keeper()\Attachments, 7)
      
      SetGadgetItemText(#Gadget_Keeper_Titles, ListIndex(Keeper()), Keeper()\Record,      8)
      
      If HighlightString.s = Keeper()\Title
        
        LineToHighLight.i = ListIndex(Keeper())
        
      EndIf
      
    Next Keeper()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClearList(Keeper())
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetState(#Gadget_Keeper_Titles, LineToHighLight.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 5
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0