﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure FillComboBoxImage(Gadget.i, DatabaseQuery.s, Storage.s, NormalIcon.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      passItemname.s     =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))
      
      passIconname.s     =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If FileSize(Storage.s  + passIconname.s) <> #NoPictureFound  And FileSize(Storage.s  + passIconname.s) <> #FileIsDirectory
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        UserIconHandle.i = LoadImage(#PB_Any, Storage.s  + passIconname.s)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If UserIconHandle.i <>  #NoPictureLoaded
          
          AddGadgetItem(Gadget.i, #AtTheEndOfTheList, passItemname.s, ImageID(UserIconHandle.i))
          
        Else
          
          AddGadgetItem(Gadget.i, #AtTheEndOfTheList, passItemname.s, ImageID(NormalIcon.i))
          
          SetInfoBarArea("Headings", "Error", "Could load the icon file as it is damaged.", #PB_Compiler_Procedure)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        AddGadgetItem(Gadget.i, #AtTheEndOfTheList, passItemname.s, ImageID(NormalIcon.i))
        
        SetInfoBarArea("Headings", "Error", "Could load the icon file as it was not found.", #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)        
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    AddGadgetItem(Gadget.i, #FirstItem, #Empty$, ImageID(NormalIcon.i))
    
    SetGadgetState(Gadget.i, #FirstItem)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error", "Database query failed or returned no data:  " + DatabaseError(), #PB_Compiler_Procedure)
    
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
    
; IDE Options = PureBasic 5.62 (Windows - x86)
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0