﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Update the attachment counter in the title list
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure UpdateTitleAttachmentCount(CurrentLine.i, CurrentRecord.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  QueryString.s = "Select COUNT(Attachmentid) "
  
  QueryString.s + "AS totalrecs FROM Attachments "
  
  QueryString.s + "WHERE Record = '"  + CurrentRecord.s + "'"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <> #DatabaseQueryFail
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If FirstDatabaseRow(Program\DatabaseHandle)
      
      NumberOfRecords.s = GetDatabaseString(Program\DatabaseHandle, 0)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

    DatabaseUpdate.s  = "UPDATE Keeper "
    
    DatabaseUpdate.s  + "Set Attachments = '" + NumberOfRecords.s + "' "
    
    DatabaseUpdate.s  + "WHERE Record = '"    + CurrentRecord.s + "'"
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CurrentTitleString.s = GetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, #TitleColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      BracketFound.i = FindString(CurrentTitleString.s, "(", 1)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If BracketFound.i <> #NothingFound
        
        CurrentTitleString.s = Trim(StringField(CurrentTitleString.s, 1, "("))
        
        SetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, CurrentTitleString.s  + " (" +  NumberOfRecords.s + ")",  #TitleColumn)
        
        SetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, NumberOfRecords.s,                                        #AttachmentsColumn)
        
      ElseIf BracketFound.i = #NothingFound 
        
        SetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, CurrentTitleString.s  + " (" +  NumberOfRecords.s + ")",  #TitleColumn)
        
        SetGadgetItemText(#Gadget_Keeper_Titles, CurrentLine.i, NumberOfRecords.s,                                        #AttachmentsColumn)
        
      EndIf    
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", "Could not update the attachment column for the current record", "AttachItem")
      
    EndIf

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf        

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 5
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableUnicode