﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Update category item count in category list
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure OneTimeCategoryUpdate()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  NewList CategoryName.s()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  DatabaseQuery.s = "SELECT Category FROM Categories"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
    
    While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
      
      AddElement(CategoryName.s())
      
      CategoryName.s()  = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ForEach CategoryName.s()
      
      CategoryQuery.s = "SELECT COUNT(Category) "

      CategoryQuery.s + "AS totalrecs FROM Keeper "

      CategoryQuery.s + "WHERE Category = '"

      CategoryQuery.s + RepQuote(CategoryName.s())

      CategoryQuery.s + "'"
      
      If DatabaseQuery(Program\DatabaseHandle, CategoryQuery.s) <> #DatabaseQueryFail
        
        While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
          
          ItemInCategoryCount.s = GetDatabaseString(Program\DatabaseHandle,  0) ; ItemInCategoryCount.s + " ::: "  + CategoryName.s()
          
        Wend
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
        If ItemInCategoryCount.s <> "0"
          
          DatabaseUpdate.s  = "UPDATE Categories "
          
          DatabaseUpdate.s  + "SET Itemcount = '"   + ItemInCategoryCount.s + "' "
          
          DatabaseUpdate.s  + "WHERE Category = '"  + RepQuote(CategoryName.s())  + "'"
          
          If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
            
            ; Update the category item count
            
          Else
            
            ;  DatabaseError()
            
          EndIf
          
        Else
          
          ;  DatabaseError()
          
        EndIf
        
      Else
        
        ; The database query failed
        
      EndIf
      
    Next  CategoryName.s()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ;  DatabaseError()
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 104
; FirstLine = 59
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableUnicode