﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Convert the rtf data in the info field to normal text
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure OneTimeConvertRtfDatabase()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s     + 

  "SELECT "         + 
  
  "Information, "   + 
  
  "Record "         + 
  
  "FROM Keeper "
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)  <> #DatabaseQueryFail
    
    While NextDatabaseRow(Program\DatabaseHandle)
      
      Information.s  = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0))
      
      Record.s       =           GetDatabaseString(Program\DatabaseHandle, 1)
      
      SetGadgetText(#Gadget_Keeper_Tempbox,         Information.s)
      
      CleanInformation.s = RepQuote(GetGadgetText(#Gadget_Keeper_Tempbox))
      
      UpdateString.s          + 

      "UPDATE Keeper "        + 

      "SET Information = '"   + 

      CleanInformation.s      + 

      "' WHERE Record = '"    + 

      Record.s  + "'"
      
      If DatabaseUpdate(Program\DatabaseHandle, UpdateString.s) <> #DatabaseUpdateFail
        
        Debug "Database update of old record worked okay  ::: " + Record.s
        
      Else
        
        Debug "Error, The database update has failed or was rooted"  + DatabaseError()
        
      EndIf
      
      QueryString.s       = #Empty$
      
      Information.s       = #Empty$
      
      Record.s            = #Empty$
      
      CleanInformation.s  = #Empty$
      
      UpdateString.s      = #Empty$
      
      SetGadgetText(#Gadget_Keeper_Tempbox, #Empty$)
      
    Wend
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
  Else
    
    Debug "Error, The database query has failed or was empty."  + DatabaseError()
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 48
; FirstLine = 37
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0