﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Update category item count in category list
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure OneTimeOwnerUpdate()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  NewList OwnerName.s()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  OwnerQuery.s  + 

  "SELECT "     + 

  "Owner "      + 

  "FROM "       + 

  "Owners"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, OwnerQuery.s) <> #DatabaseQueryFail
    
    While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
      
      AddElement(OwnerName.s())
      
      OwnerName.s()  = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ForEach OwnerName.s()
      
      DatabaseQuery.s             + 

      "SELECT COUNT(Owner) "      + 
      
      "AS totalrecs FROM Keeper " + 
      
      "WHERE Owner = '"           + 

      RepQuote(OwnerName.s())     + 

      "'"
      
      If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
        
        While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
          
          ItemInOwnerCount.s = GetDatabaseString(Program\DatabaseHandle,  0)
          
        Wend
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
        If ItemInOwnerCount.s <> "0"
          
          DatabaseUpdate.s        + 

          "UPDATE Owners "        + 
          
          "SET Itemcount = '"     + 

          ItemInOwnerCount.s      + 

          "' "                    + 
          
          "WHERE Category = '"    + 

          RepQuote(OwnerName.s()) + 

          "'"
          
          If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
            
            ; Update the category item count
            
          Else
            
            ; The database update failed
            
          EndIf
          
        Else
          
          ; No items in this category
          
        EndIf
        
      Else
        
        ; The database query failed
        
      EndIf
      
      DatabaseQuery.s     = #Empty$
      
      DatabaseUpdate.s    = #Empty$
      
      ItemInOwnerCount.s  = #Empty$
      
    Next  OwnerName.s()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ; The database query failed
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 32
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0