;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Turn tool tips on and off as needed
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ToggleBalloonToolTips()

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  Protected Message.s
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\BalloonTooltips = #True
  
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    Toggle\BalloonTooltips = #False
    
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    Message.s = "The global form tool tips have now been turned off." 
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

  ElseIf Toggle\BalloonTooltips = #False
  
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    Toggle\BalloonTooltips = #True
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

    Message.s = "The global form tool tips have now been turned on."
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------

  EndIf

  ;------------------------------------------------------------------------------------------------
  ; Turn the tooltips on or off as needed with the API state
  ;------------------------------------------------------------------------------------------------
  
  ForEach ToolTips()
  
    SendMessage_(ToolTips()\pbHandleTip, #TTM_ACTIVATE, Toggle\BalloonTooltips, 0)

  Next
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

  SetMenuItemState(#MenuBar_Keeper,  #MenuBar_Keeper_BalloonTooltips,  Toggle\BalloonTooltips)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  SetInfoBarArea("Headings", "Info", Message.s, #PB_Compiler_Procedure)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  UpdateString.s              + 

  "UPDATE Preferences "       + 
  
  "SET BalloonTooltips = '"   + 

  Str(Toggle\BalloonTooltips) + 

  "' "                        + 
  
  "WHERE Record = '1'"
  
  DatabaseUpdate(Program\DatabaseHandle, UpdateString.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 87
; FirstLine = 76
; Folding = -
; DisableDebugger
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0