﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Turn time updating on in the title bar
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ToggleTitleBarClock()
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\TitleClock = #True
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    Toggle\TitleClock = #False
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    KillTimer_(WindowID(#Window_Keeper), #TitleBarClockTimer)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetWindowTitle(#Window_Keeper, #Fish + #Basename + #Version)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings", "Info", "The titlebar clock is now switched off.")
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  ElseIf Toggle\TitleClock = #False
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    Toggle\TitleClock = #True
    
    ;----------------------------------------------------------------------------------------------
    ; Create the permanent timer
    ;----------------------------------------------------------------------------------------------
    
    SetTimer_(WindowID(#Window_Keeper), #TitleBarClockTimer, 1000, @TitleBarClock())    ; 1000 = 1 second
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings", "Info",  "The titlebar clock is now switched on.")
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SetMenuItemState(#MenuBar_Keeper, #MenuBar_Keeper_TitleClock, Toggle\TitleClock)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  UpdateString.s          +

  "UPDATE Preferences "   + 
  
  "SET TitleClock = '"    + 

  Str(Toggle\TitleClock)  + 

  "' "                    + 
  
  "WHERE Record = '1'"
  
  DatabaseUpdate(Program\DatabaseHandle, UpdateString.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;  SetTimer_(WindowID(#Window_Keeper), #TitleBarClockTimer, 1000, @TitleBarClock())    ; 1000 = 1 second
; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 91
; FirstLine = 55
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0