﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Turn on or off the showing of the main toolbar
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ToggleWindowToolBars()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\ShowToolbar = #False
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Toggle\ShowToolbar = #True
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    MessageString.s = "The main program toolbar is now turned on. Press "
    
    MessageString.s + GetShortCutText(#ShortcutValue_ShowToolbar) + " to turn back off again"

    SetInfoBarArea("Headings", "Info", MessageString.s)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    HideGadget(#Gadget_Keeper_cControl, #False)

    ResizeWindow(#Window_Keeper,          #PB_Ignore, #PB_Ignore, #PB_Ignore, 871)
    
    ResizeGadget(#Gadget_Keeper_cStatus,  0,          825,        #PB_Ignore, #PB_Ignore)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  ElseIf Toggle\ShowToolbar = #True
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Toggle\ShowToolbar = #False
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings", "Info", "The main toolbar is now turned off")
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    HideGadget(#Gadget_Keeper_cControl, #True)
    
    CurrentWindowHeight.i     = WindowHeight(#Window_Keeper)    ; Height of the window
    
    CurrentControlbarHeight.i = 75                              ; Height of the control bar
    
    CurrentStatusbarHeight.i  = 20                              ; Height of the status bar
    
    ResizeWindow(#Window_Keeper,          #PB_Ignore, #PB_Ignore, #PB_Ignore, CurrentWindowHeight.i  - CurrentControlbarHeight.i)
    
    ResizeGadget(#Gadget_Keeper_cStatus,  #PB_Ignore, CurrentWindowHeight.i - CurrentControlbarHeight.i - CurrentStatusbarHeight.i  - 20, #PB_Ignore, #PB_Ignore)

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SetMenuItemState(#MenuBar_Keeper, #MenuBar_Keeper_ShowToolBar, Toggle\ShowToolbar)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  UpdateString.s              + 

  "UPDATE Preferences "       + 
  
  "SET ShowToolbar = '"       + 

  Str(Toggle\ShowToolbar)     + 

  "' "                        + 
  
  "WHERE Record = '1'"
  
  DatabaseUpdate(Program\DatabaseHandle, UpdateString.s)  
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
;   Debug "Current toolbar state: " + Str(Toggle\ShowToolbar)
;   
;   Debug UpdateString.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
  

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 35
; FirstLine = 15
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0