;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Show the program window now
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ShowProgramWindow()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Program\LockState <> #True
    
    ;----------------------------------------------------------------------------------------------
    ; Set tray semaphore to show that we don't need it
    ;----------------------------------------------------------------------------------------------
    
    Program\TrayState = #False
    
    ;----------------------------------------------------------------------------------------------
    ; Remove the tray ico, not needed any more
    ;----------------------------------------------------------------------------------------------
    
    RemoveSysTrayIcon(#Systray_Tray)
    
    ;----------------------------------------------------------------------------------------------
    ; Hide the window now
    ;----------------------------------------------------------------------------------------------
    
    HideWindow(#Window_Keeper, #False)
    
    ;----------------------------------------------------------------------------------------------
    ; Hide the window now
    ;----------------------------------------------------------------------------------------------
    
    DisableWindow(#Window_Keeper, #False)
    
    ;----------------------------------------------------------------------------------------------
    ; Unhiding doesn't show the window sadly
    ;----------------------------------------------------------------------------------------------
    
    SetWindowState(#Window_Keeper, #PB_Window_Normal)
    
    ;----------------------------------------------------------------------------------------------
    ; Un-hiding the window brings it to the front
    ;----------------------------------------------------------------------------------------------
    
    SetActiveWindow(#Window_Keeper)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    UnLockProgramWindow()
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 63
; FirstLine = 20
; Folding = -
; EnableXP
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0